Page MenuHomePhabricator

Decide from which release branch we should drop PHP 7.3 support
Closed, ResolvedPublic

Description

PHP 7.3 is EOL upstream as of December 2021 - https://www.php.net/supported-versions.php

Do we want to drop support for PHP 7.3 in MW-1.38-release or MW-1.39-release?

By the time 1.38 is released in May 2022, PHP 7.3 will be EOL for ~6 months, and for 1.39, 11 months.

Definitely wants to happen in/for MW 1.39, but the question is whether we want to get it included in MW 1.38 too.

Obviously, master will still support PHP 7.2 until T271736: Migrate WMF production from PHP 7.2 to PHP 7.4 has happened, and if we do drop PHP 7.3 in the release branch, it'll be a soft drop (same as for PHP 7.2 in current release branches).

Event Timeline

Reedy updated the task description. (Show Details)
Reedy renamed this task from Drop support for PHP 7.3 from next reelease branch? to Drop support for PHP 7.3 from next release branch?.Jan 10 2022, 10:04 PM

I think 1.38 makes sense per our timings policy we worked out for 1.35, but I'd be OK to delay to 1.39 if someone cares very passionately.

(It wouldn't be an entirely soft drop; we'd kill the PHP 7.3 CI jobs entirely, as they'll not catch anything we care about, so CI load would go down slightly. There also might be some odd PHP 7.3-only code which we could immediately drop, but if there is I can't see it.)

Subtask, maybe. This is about trying to work out the decision of when this happens

https://pingback.wmflabs.org/#php-version

PHP 7.3 is the second most PHP version (after PHP 7.4), which isn't really a surprise.

Unfortunately the pingback dashboards haven't been kept upto date (later MW releases), making doing the evaluation a little harder as to what people are actually running on what MW version etc. Just filed T298922: Update pingback "PHP Version" dashboards for that.

Subtask, maybe. This is about trying to work out the decision of when this happens

Also, in a release branch we will probably make that more restrictive than master (like we did for PHP 7.2 being still supported in master, but not the last few release branches). We won't start updating code to use PHP 7.3 (or later) features until that support has happened in master.

Reedy renamed this task from Drop support for PHP 7.3 from next release branch? to Which release branch should we drop PHP 7.3 support from?.Jan 10 2022, 11:15 PM
Jdforrester-WMF renamed this task from Which release branch should we drop PHP 7.3 support from? to Decide from which release branch we should drop PHP 7.3 support.Jan 10 2022, 11:16 PM

If we're doing this for 1.38, we need to make this decision in the next few days. The release cut is in 12 days' time.

Krinkle added a subscriber: Krinkle.

I think it's hard enough as it is pretending not to support PHP 7.2 in MW master. I suggest holding off until 1.39 and hopefully by then we're further along with T271736: Migrate WMF production from PHP 7.2 to PHP 7.4.

However, we if we were to remove the hard-fail and make it advisory in docs and installer only, then we could be more progessive with dropping support "officially".

1.39 is more “important” to decide being an lts

Jdforrester-WMF assigned this task to Krinkle.

The choice is 1.38 or 1.39. Sounds like we've decided that we're dropping it for 1.39. WFM.